/*
 *		\
 *
 *		Copyright	T.Koabayashi	1994.6.26
 */

#define	VIEW	1

#ifndef	POLY
#include "poly.h"
#endif

#ifndef	MATRIX
#include "matrix.h"
#endif

#ifndef	ON
	#define	ON		1
	#define	OFF		0
#endif

#ifndef WINDOWS
#define	MENU_WIDTH		(FontV+2)	/*	j[o[̑傫	*/
#else
#define	MENU_WIDTH	0
#endif
#define	FRAME_WIDTH		12			/*	t[̕			*/
#define STATUS_WIDTH	(FontV+6)	/*	Xe[^Xo[̍	*/

/*	}̃}EXJ[\	*/
#define	PERS_CURSOR_OFF	0
#define	PERS_CURSOR_2D	1
#define	PERS_CURSOR_3D	2

/*	J[R[h	*/
#define	GRID_COLOR		9
#define	FRAME_COLOR		10
#define INVISIBLE_COLOR	11
#define	BG_COLOR		13
#define	SELECT_COLOR	14
#define	TMP_COLOR		16
#define	OR_COLOR		17
#define	CURSOR_COLOR	18

/*	\^Cv	*/
#define	VIEW_XY		1
#define	VIEW_YZ		2
#define	VIEW_ZX		4
#define	VIEW_PERS	8
#define	VIEW_ALL	15

#define CURSOR_2D_SHIFT 16

typedef	struct	{
	int		x, y ;			/*	ʒu		*/
	int		h, v ;			/*	傫		*/
	int		offx, offy ;	/*	ItZbg	*/
}
	ViewWindow ;

extern	int			ViewMode ;
extern	ViewWindow	WinXY, WinYZ, WinZX, WinPers ;
extern	int			VisibleVector ;				/*	@xNg\[h	*/
extern	int			VisiblePolyVector ;			/* 	ʖ@\[h		*/
extern	int			VisibleVertex ;				/*	_\[h			*/
extern	int			InvisibleDraw ;				/* 	Invisible`悷邩	*/
extern	int			DrawFrontOnlyFlag ;			/*  \݂̂`悷邩		*/
extern	int			Cx, Cy, Cz ;				/*	Sʒu				*/
extern	int			ZoomPlus, ZoomMinus ;		/*	Y[l				*/
extern	int			GridDisplay ;				/*	\Obh			*/
extern	int			WinMove ;					/*	EChEړ		*/
extern	int			GridCursor ;				/*	J[\ړObh	*/
extern	int			PersMat[5][3] ;				/*	}ps			*/
extern	Matrix		PersMatInv;
extern	int			ConvFlag ;					/*	ϊ				*/
extern	int			ConvMat[5][3] ;				/*	ϊps				*/
extern	int			ConvInv[5][3] ;				/*	ϊpts			*/
extern	int			Mx, My, Mz, Mstat ;			/*	3D }EXJ[\		*/
extern	int			PersMx, PersMy, PersMstat ;	/*	2D }EXJ[\		*/
extern	int			MouseWin ;					/*	}EX̂EChE	*/
extern	int			PersOffsetX, PersOffsetY, PersScaleX, PersAngleCount;

#ifdef __cplusplus
extern "C" {
#endif
/*	view1.c	*/
extern	void	ViewInit( int, int );
extern	void	ViewSetWindow( int );
extern	void	ViewSetDisplay( int, int );
extern	void	ViewSetCenter( int, int, int );
extern	void	ViewSetZoom( int, int );
extern	void	ViewSetPers( Matrix );
extern	void	ViewSetGrid( int, int );
extern	void	ViewSetConv( Matrix );
extern	void	ToScreen( int[3], Vertex* );
extern	int		ToScreenPers( int*, Vertex* );
extern	int		ScreenFront( short* );
extern	void	MatToInt( int[5][3], Matrix );
extern	int		PersAngle(int angle);

/*	view2.c	*/
extern	void	ViewCursor( int );
extern	void	ViewCursorPers( int );
extern	void	ViewSet3DCursorPos( int, int, int );
extern	int		MouseWindow( int, int );
extern	void	ViewCursorPos( int, int );
extern	void	Get3DCursor( int*, int*, int* );
extern	int		ScrollCheck(int, int);

/*	view3.c	*/
extern	void	ViewFrame( void );
extern	void	ViewClear( int );
extern	void	ViewLineAll( int, int, int, int, int );
extern	void	ViewLineSelectAll( void );
extern	void	ViewCurrent( void );
extern	void	ViewLine3D( Vertex*, Vertex*, int );
extern	void	ViewLinePersAll( int );
extern	void	ViewLinePers( Vertex*, Vertex*, int );
extern	void	DrawLineForWin( int[3], int[3], int );
extern	void	DrawLineForPers( Vertex*, Vertex*, int );
extern	void	ViewTempForWin(void);
extern	void	ViewTempForPers(void);
extern	void	ClipLine( ViewWindow*, int, int, int, int, int );
extern	void	ViewLine2D( int, int, int, int, int );
extern	void	DrawBoxForWin( int[3], int );
extern	void	DrawBoxForPers( Vertex*, int );
extern	void	ClipBox( ViewWindow*, int, int, int, int, int );
extern	void	ViewVertex(Vertex *p1, int color);

/*	view4.c	*/
extern	void	ViewBox( Vertex*, Vertex*, Matrix );
extern	void	ViewBox2D( int, int, int, int );

/*	viewlib.c	*/
extern	void	ViewLibInit( void );
#ifdef __cplusplus
}
#endif

